import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import "core-js/modules/es6.regexp.match";
import React, { Component } from 'react';
import omit from 'lodash.omit';
var omitProps = ['LoadingComp', 'ErrorComp', 'Layout', 'homePage', 'getPagePath'];

var DefaultLoadingComp = function DefaultLoadingComp() {
  return React.createElement("div", {
    className: "page_proxy_waiting_element"
  });
};

var DefaultErrorComp = function DefaultErrorComp() {
  return React.createElement("div", {
    className: "page_proxy_error_element"
  });
};

var STR_DEFAULT = 'default'; //缓存当前的pagePath, 用来和新pagePath做对比，用来清空状态

var currentPagePath = '';

function getPagePath(props) {
  var getPagePath = props.getPagePath,
      url = props.match.url,
      _props$homePage = props.homePage,
      homePage = _props$homePage === void 0 ? 'home' : _props$homePage;
  if (typeof getPagePath === 'function') return getPagePath(props) || homePage;
  return url.substr(1) || homePage;
}

var PageProxy =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(PageProxy, _Component);

  function PageProxy() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      hasError: false
    };
    return _this;
  }

  PageProxy.getDerivedStateFromError = function getDerivedStateFromError(error) {
    return {
      hasError: true,
      error: error
    };
  } //当上个路由出错时，切换页面清楚错误
  ;

  PageProxy.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    var newPagePath = getPagePath(props);

    if (newPagePath !== currentPagePath && state.hasError) {
      return {
        hasError: false,
        error: null
      };
    }

    return null;
  };

  var _proto = PageProxy.prototype;

  _proto.getPageComp = function getPageComp() {
    var LoadingComp = this.props.LoadingComp;
    var pagePath = currentPagePath = getPagePath(this.props);
    var Page = this.state[pagePath];

    if (Page) {
      var useLayout = Page.useLayout;
      this.useLayout = typeof useLayout === 'boolean' ? useLayout : true; //缓存当前useLayout的状态，进入下一个页面的时候避免发生layout的切换导致的闪动

      return [Page, this.useLayout];
    } //读取之前的layout状态，如果不存在就用true


    this.loadAsyncPages(pagePath);
    var ul = this.useLayout === 'boolean' ? this.useLayout : true;
    return [LoadingComp || DefaultLoadingComp, ul];
  };

  _proto.render = function render() {
    var _this$props = this.props,
        ErrorComp = _this$props.ErrorComp,
        Layout = _this$props.Layout;
    var omittedProps = omit(this.props, omitProps);

    if (this.state.hasError) {
      if (ErrorComp) {
        return React.createElement(ErrorComp, _extends({
          error: this.state.error
        }, omittedProps));
      } else {
        console.error(this.state.error);
        return React.createElement(DefaultErrorComp, null);
      }
    }

    var _this$getPageComp = this.getPageComp(),
        Page = _this$getPageComp[0],
        useLayout = _this$getPageComp[1];

    if (!useLayout || !Layout) return React.createElement(Page, omittedProps);
    return React.createElement(Layout, omittedProps, React.createElement(Page, omittedProps));
  };

  _proto.loadAsyncPages = function loadAsyncPages(path) {
    var _this2 = this;

    import(
    /* webpackMode: "lazy", webpackChunkName: "[request]" */
    "_/src/pages/" + path + "/page-view").then(function (loadedModule) {
      var _this2$setState;

      var PageComponent = loadedModule[STR_DEFAULT];

      if (!PageComponent) {
        _this2.setState({
          hasError: true,
          error: new Error("Component under [" + path + "] is not found, make sure the default exports was made correspondingly in the " + path + " page-view")
        });
      }

      _this2.setState((_this2$setState = {}, _this2$setState[path] = PageComponent, _this2$setState));
    }).catch(function (err) {
      _this2.setState({
        hasError: true,
        error: err
      });
    });
  };

  return PageProxy;
}(Component);

export { PageProxy as default };